setwd("/Users/acortes/Documents/Research/ParamoGBS/R")
mds<-read.table("MDS_r.txt",sep="\t",header=TRUE)
mds$pop<-as.factor(substr(mds$taxa,1,2)) 
mds$sp<-as.factor(substr(mds$taxa,3,4))
mds$pop_sp<-as.factor(substr(mds$taxa,1,4))

#PCA with names color file
names<-read.table("codes.txt",sep="\t",header=TRUE)
names$color<-as.character(names$color)

mds<-merge(mds,names[,c("pop_sp","color")],by="pop_sp")
mds<-merge(mds,names[,c("pop_sp","pch")],by="pop_sp")
mds<-merge(mds,names[,c("pop_sp","name")],by="pop_sp")
mds<-merge(mds,names[,c("pop_sp","name_short")],by="pop_sp")
mds$color<-as.character(mds$color)

cex_v<-0.9
par(mfrow=c(1,1))
par(mar=c(4,4,1,1)+0.1)
plot(PC2~PC1,mds,pch=mds$pch,cex=cex_v,col=mds$color,las=1,xlab="PCoA (42%)",ylab="PCoA (36%)")
abline(h=0,lty=2, col="darkgray")
abline(v=0,lty=2, col="darkgray")
names<-names[order(names$lat_order),]
legend(x="topleft",legend=names$name_short2,col=names$color,bty="n",cex=cex_v,pch=names$pch,y.intersp=1.3)
#legend(x="topleft",legend=paste(names$name," - ",names$name_short,sep=""),text.col="darkgray",col=names$color,bty="n",cex=cex_v,pch=names$pch,y.intersp=1.3)
names<-names[order(names$pop,names$name),]

par(mfrow=c(1,1))
plot(PC2~PC1,mds,pch=mds$pch,cex=1.2,col=mds$color,las=1,xlim=c(-0.075,-0.03),ylim=c(-0.015,0.015),xlab="PCoA (42%)",ylab="PCoA (36%)")
abline(h=0,lty=2, col="darkgray")
names2<-names[c(1:3,9:10,17:19),]
names2<-names2[order(names2$lat_order),]
legend(x="topleft",legend=names2$name_short,col=names2$color,bty="n",cex=1,pch=names2$pch,y.intersp=1.3)
names2<-names2[order(names2$pop,names2$name),]

#Fst & Fis
snps<-read.table("162_1273_r.txt",sep="\t",header=TRUE)
snps<-read.table("65_897_r.txt",sep="\t",header=TRUE)
snps<-read.table("97_812_r.txt",sep="\t",header=TRUE)

snps$pop_sp<-as.factor(substr(snps$id,1,4))
table(snps$pop_sp)
pop_sp<-names(table(snps$pop_sp))
snp_n<-dim(snps)[2]-2

ho_he(snps[,2])
ho_he<-function(df){
  s<-df
  counts<-as.data.frame(table(s))
  counts<-counts[counts$s!="N",]
  h<-counts[!counts$s %in% c("A","C","G","T"),]
  alleles<-counts[counts$s %in% c("A","C","G","T"),]
  p<-(alleles[1,"Freq"]*2+h[1,"Freq"])/(alleles[1,"Freq"]*2+h[1,"Freq"]*2+alleles[2,"Freq"]*2)
  q<-(alleles[2,"Freq"]*2+h[1,"Freq"])/(alleles[1,"Freq"]*2+h[1,"Freq"]*2+alleles[2,"Freq"]*2)
  ho<-h[1,"Freq"]/(alleles[1,"Freq"]+h[1,"Freq"]+alleles[2,"Freq"])
  he<-2*p*q
  return(c(ho,he))
}

snp_n_saved<-snp_n

snp_n<-snp_n_saved
snps<-snps_alt
snps<-snps_hum
snps<-snps_pop

snp_n<-dim(snps)[2]-2
markers<-c(2:(snp_n+1))
for(m in markers){
  pw_fst<-matrix(nrow=length(pop_sp),ncol=length(pop_sp))
  rownames(pw_fst)<-pop_sp
  colnames(pw_fst)<-pop_sp
  
  pw_fis<-matrix(nrow=length(pop_sp),ncol=length(pop_sp))
  rownames(pw_fis)<-pop_sp
  colnames(pw_fis)<-pop_sp
  
  pw_he<-matrix(nrow=length(pop_sp),ncol=length(pop_sp))
  rownames(pw_he)<-pop_sp
  colnames(pw_he)<-pop_sp
  for(i in pop_sp){
    run<-T
    for(j in pop_sp){
      if(i==j){run<-F}
      if(run==T){
        he_1<-ho_he(snps[snps$pop_sp==i,m])[2]
        he_2<-ho_he(snps[snps$pop_sp==j,m])[2]
        he<-ho_he(snps[snps$pop_sp==i|snps$pop_sp==j,m])[2]
        fst<-(he-(he_1+he_2)/2)/he
        if((!is.na(fst))&fst<0){fst<-0}
        pw_fst[i,j]<-fst
        pw_he[i,j]<-he
        
        ho<-ho_he(snps[snps$pop_sp==i|snps$pop_sp==j,m])[1]
        fis<-(he-ho)/he
        if((!is.na(fis))&fis<0){fis<-0}
        pw_fis[i,j]<-fis
      }
    }
  }
  if(m==2){mk<-pw_fst;mki<-pw_fis;mkhe<-pw_he}
  if(m==3){mk<-list(mk,pw_fst);mki<-list(mki,pw_fis);mkhe<-list(mkhe,pw_he)}
  if(m>3){mk[[m-1]]<-pw_fst;mki[[m-1]]<-pw_fis;mkhe[[m-1]]<-pw_he}
  if(m%%50==0){print(m)}
}

mk_saved<-mk
save(mk_saved, file="pw_fst_Pop.RData")
mki_saved<-mki
save(mki_saved, file="pw_fis_Pop.RData")
mkhe_saved<-mkhe
save(mkhe_saved, file="pw_he_Pop.RData")

pop_sp_short<-merge(data.frame(pop_sp=pop_sp),names[,c("pop_sp","name_short")],by="pop_sp")[,"name_short"]

mk<-array(unlist(mk),c(length(pop_sp_short),length(pop_sp_short),snp_n))
pw_fst_f<-rowMeans(mk,dims=2,na.rm=T)
colnames(pw_fst_f)<-pop_sp_short
rownames(pw_fst_f)<-pop_sp_short
write.table(pw_fst_f, file="pw_fst_f_Pop.txt", sep="\t", dec = ".")

mki<-array(unlist(mki),c(length(pop_sp_short),length(pop_sp_short),snp_n))
pw_fis_f<-rowMeans(mki,dims=2,na.rm=T)
colnames(pw_fis_f)<-pop_sp_short
rownames(pw_fis_f)<-pop_sp_short
write.table(pw_fis_f, file="pw_fis_f_Pop.txt", sep="\t", dec = ".")

mkhe<-array(unlist(mkhe),c(length(pop_sp_short),length(pop_sp_short),snp_n))
pw_he_f<-rowMeans(mkhe,dims=2,na.rm=T)
colnames(pw_he_f)<-pop_sp_short
rownames(pw_he_f)<-pop_sp_short
write.table(pw_he_f, file="pw_he_f_Pop.txt", sep="\t", dec = ".")

#Prepare files for Mantels

pw_fst_f<-read.table("pw_fst_f.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_alt.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_alt.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_alt.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_hum.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_hum.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_hum.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_pop.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_pop.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_pop.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_alt_ecol.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_alt_ecol.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_alt_ecol.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_hum_ecol.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_hum_ecol.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_hum_ecol.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_pop_ecol.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_pop_ecol.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_pop_ecol.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_alt_pop.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_alt_pop.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_alt_pop.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_pop_pop.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_pop_pop.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_pop_pop.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_Ecol.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_Ecol.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_Ecol.txt",sep="\t",header=TRUE)

pw_fst_f<-read.table("pw_fst_f_Pop.txt",sep="\t",header=TRUE)
pw_fis_f<-read.table("pw_fis_f_Pop.txt",sep="\t",header=TRUE)
pw_he_f<-read.table("pw_he_f_Pop.txt",sep="\t",header=TRUE)

pw_fst_f[is.na(pw_fst_f)]<-0;pw_fst_f<-pw_fst_f+t(pw_fst_f);pw_fst_f<-as.matrix(pw_fst_f)
pw_fis_f[is.na(pw_fis_f)]<-0;pw_fis_f<-pw_fis_f+t(pw_fis_f);pw_fis_f<-as.matrix(pw_fis_f)
pw_he_f[is.na(pw_he_f)]<-0;pw_he_f<-pw_he_f+t(pw_he_f);pw_he_f<-as.matrix(pw_he_f)

#Pop tendencies
library(ape)
mantel.test(pw_fst_f,pw_he_f,nperm = 999)
mantel.test(pw_fst_f,pw_fis_f,nperm = 999)

par(mfrow=c(1,2))
par(mar=c(5,5,1,1)+0.1)
pw_fst_f_s<-pw_fst_f;diag(pw_fst_f)<-NA;pw_fst_f[lower.tri(pw_fst_f)]<-NA
pw_he_f_s<-pw_he_f;diag(pw_he_f)<-NA;pw_he_f[lower.tri(pw_he_f)]<-NA
pw_fis_f_s<-pw_fis_f;diag(pw_fis_f)<-NA;pw_fis_f[lower.tri(pw_fis_f)]<-NA
plot(pw_he_f,pw_fst_f,pch=19,las=1,ylab=expression(F[ST]),xlab=expression(H[e]),cex=0.8)
lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_he_f)[!is.na(as.vector(pw_he_f))],fitted(lm(as.vector(pw_fst_f)~as.vector(pw_he_f))))
legend(x="topleft",legend="A",bty="n",cex=1)
plot(pw_fis_f,pw_fst_f,pch=19,las=1,ylab=expression(F[ST]),xlab=expression(F[IS]),cex=0.8)
lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_fis_f)[!is.na(as.vector(pw_fis_f))],fitted(lm(as.vector(pw_fst_f)~as.vector(pw_fis_f))))
legend(x="topleft",legend="B",bty="n",cex=1)
pw_fst_f<-pw_fst_f_s
pw_he_f<-pw_he_f_s

library(qgraph)
pdf('net_pop.pdf', width=100, height=100)
qgraph(1/pw_fst_f, layout='spring', vsize=3)
dev.off()

#Mantel geo & env
library(geosphere)
geo<-names[,c("lon","lat")]
rownames(geo)<-names$name_short
#rownames(geo)<-names$pop_sp
geo<-geo[rownames(pw_fst_f),]
pw_geo<-as.matrix(distm(geo,fun=distHaversine))
rownames(pw_geo)<-rownames(geo)
colnames(pw_geo)<-rownames(geo)
#rownames(pw_geo)<-names$pop_sp
#colnames(pw_geo)<-names$pop_sp

eco_alt<-names[,c("eco_alt")]
names(eco_alt)<-names$name_short
eco_alt<-eco_alt[rownames(pw_fst_f)]
#names(eco_alt)<-names$pop_sp
pw_eco_alt<-as.matrix(dist(eco_alt,method="euclidean",diag=T,upper=T))

eco_hum<-names[,c("eco_hum")]
names(eco_hum)<-names$name_short
eco_hum<-eco_hum[rownames(pw_fst_f)]
#names(eco_hum)<-names$pop_sp
pw_eco_hum<-as.matrix(dist(eco_hum,method="euclidean",diag=T,upper=T))

mantel.test(pw_fst_f/(1-pw_fst_f),pw_geo,nperm = 999)
mantel.test(pw_fst_f/(1-pw_fst_f),pw_eco_alt,nperm = 999)
mantel.test(pw_fst_f/(1-pw_fst_f),pw_eco_hum,nperm = 999)

library(vegan)
plot(mantel.correlog(pw_fst_f/(1-pw_fst_f),pw_geo,nperm=999),alpha=0.05)

par(mfrow=c(1,3))
par(mar=c(5,5,1,1)+0.1)
plot(pw_geo/1000,pw_fst_f/(1-pw_fst_f),pch=19,las=1,ylab=expression(F[ST]/(1-F[ST])),xlab="Geographic distance (Km)",cex=1,cex.lab=1.3,cex.axis=1.3)
lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_geo/1000),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_geo/1000))))
legend(x="topleft",legend="A",bty="n",cex=1)
plot(jitter(pw_eco_alt),pw_fst_f/(1-pw_fst_f),xaxt='n',pch=19,las=1,ylab=expression(F[ST]/(1-F[ST])),xlab="Ecological distance ('Humidity')",cex=1,cex.lab=1.3,cex.axis=1.3)
axis(1,at=0:2,labels=LETTERS[1:3])
legend(x="topleft",legend="B",bty="n",cex=1)
plot(jitter(pw_eco_hum),pw_fst_f/(1-pw_fst_f),xaxt='n',pch=19,las=1,ylab=expression(F[ST]/(1-F[ST])),xlab="Ecological distance ('Frost')",cex=1,cex.lab=1.3,cex.axis=1.3)
axis(1,at=0:2,labels=LETTERS[1:3])
legend(x="topleft",legend="C",bty="n",cex=1)

#Mantel geo & env in a for

library(geosphere)
library(vegan)
library(qgraph)
library(ape)
library(reshape2)

names<-read.table("codes.txt",sep="\t",header=TRUE)
names$color<-as.character(names$color)
files<-c("pw_fst_f.txt","pw_fst_f_pop.txt","pw_fst_f_alt.txt","pw_fst_f_hum.txt","pw_fst_f_Pop.txt","pw_fst_f_pop_pop.txt","pw_fst_f_alt_pop.txt","pw_fst_f_hum_pop.txt","pw_fst_f_Ecol.txt","pw_fst_f_pop_ecol.txt","pw_fst_f_alt_ecol.txt","pw_fst_f_hum_ecol.txt")

#Migration statistics basic
#1, 5, 9
i<-9
pw_fst_f<-read.table(files[i],sep="\t",header=TRUE)
ne<-(1/pw_fst_f-1)/4
ne[which(ne==Inf)]<-NA
ne<-as.matrix(ne)
max(ne,na.rm=T)
sd(ne,na.rm=T)/sqrt(dim(ne)[1]*(dim(ne)[1]-1)/2)
mean(ne,na.rm=T)
quantile(ne,prob=c(0.25,0.975),na.rm=T)

#Migration statistics intra and inter, for entire, locality-based and habitat-based datasets
#1:4, 5:7, 9:12
mean_in<-NA
se_in<-NA
ci_in1<-NA
ci_in2<-NA
mean_bt<-NA
se_bt<-NA
ci_bt1<-NA
ci_bt2<-NA
for(i in 9:12){
  pw_fst_f<-read.table(files[i],sep="\t",header=TRUE)
  ne<-(1/pw_fst_f-1)/4
  ne[which(ne==Inf)]<-NA
  ne<-as.matrix(ne)
  for(j in names(table(substr(rownames(ne),1,2)))){
    nen<-ne
    rownames(nen)<-substr(rownames(ne),1,2)
    colnames(nen)<-substr(rownames(ne),1,2) 
    nen<-nen[rownames(nen)==j,colnames(nen)==j]
    if(is.na(mean_in)){
      mean_in<-mean(nen,na.rm=T)
      se_in<-sd(nen,na.rm=T)/sqrt(dim(nen)[1]*(dim(nen)[1]-1)/2)
      ci_in1<-quantile(nen,prob=c(0.25),na.rm=T)
      ci_in2<-quantile(nen,prob=c(0.975),na.rm=T)
    }
    if(!is.na(mean_in)){
      mean_in<-c(mean_in,mean(nen,na.rm=T))
      se_in<-c(se_in,sd(nen,na.rm=T)/sqrt(dim(nen)[1]*(dim(nen)[1]-1)/2))
      ci_in1<-c(ci_in1,quantile(nen,prob=c(0.25),na.rm=T))
      ci_in2<-c(ci_in2,quantile(nen,prob=c(0.975),na.rm=T))
    }
  }
  for(j in names(table(substr(rownames(ne),3,3)))){
    nen<-ne
    rownames(nen)<-substr(rownames(ne),3,3)
    colnames(nen)<-substr(rownames(ne),3,3)
    nen<-nen[rownames(nen)==j,colnames(nen)==j]
    if(is.na(mean_in)){
      mean_bt<-mean(nen,na.rm=T)
      se_bt<-sd(nen,na.rm=T)/sqrt(dim(nen)[1]*(dim(nen)[1]-1)/2)
      ci_bt1<-quantile(nen,prob=c(0.25),na.rm=T)
      ci_bt2<-quantile(nen,prob=c(0.975),na.rm=T)
    }
    if(!is.na(mean_in)){
      mean_bt<-c(mean_bt,mean(nen,na.rm=T))
      se_bt<-c(se_bt,sd(nen,na.rm=T)/sqrt(dim(nen)[1]*(dim(nen)[1]-1)/2))
      ci_bt1<-c(ci_bt1,quantile(nen,prob=c(0.25),na.rm=T))
      ci_bt2<-c(ci_bt2,quantile(nen,prob=c(0.975),na.rm=T))
    }
  }
}
print(mean(mean_in,na.rm=T))
print(mean(se_in,na.rm=T))
print(mean(ci_in1,na.rm=T))
print(mean(ci_in2,na.rm=T))
print(mean(mean_bt,na.rm=T))
print(mean(se_bt,na.rm=T))
print(mean(ci_bt1,na.rm=T))
print(mean(ci_bt2,na.rm=T))
t.test(mean_in,mean_bt,alternative="two.sided")
p.adjust(print(t.test(mean_in,mean_bt,alternative="two.sided"))$p.value,method="bonferroni",n=dim(ne)[2]*(dim(ne)[2]-1)/2*3)

#Fst for AMOVA

pw_fst_f<-read.table("pw_fst_f.txt",sep="\t",header=TRUE)
intra_loc<-0
inter_loc<-0
intra_h<-0
inter_h<-0
intra_loc_c<-0
inter_loc_c<-0
intra_h_c<-0
inter_h_c<-0
for(i in 1:dim(pw_fst_f)[1]){
  for(j in 1:dim(pw_fst_f)[2]){
    if(substr(rownames(pw_fst_f),1,2)[i]!=substr(colnames(pw_fst_f),1,2)[j]){
      inter_loc<-sum(inter_loc,pw_fst_f[i,j],na.rm=T)
      if(!is.na(pw_fst_f[i,j])){inter_loc_c<-inter_loc_c+1}
    }
    if(substr(rownames(pw_fst_f),1,2)[i]==substr(colnames(pw_fst_f),1,2)[j]&
       substr(rownames(pw_fst_f),3,3)[i]!=substr(colnames(pw_fst_f),3,3)[j]){
      intra_loc<-sum(intra_loc,pw_fst_f[i,j],na.rm=T)
      if(!is.na(pw_fst_f[i,j])){intra_loc_c<-intra_loc_c+1}
    }
    if(substr(rownames(pw_fst_f),1,2)[i]==substr(colnames(pw_fst_f),1,2)[j]&
       substr(rownames(pw_fst_f),3,3)[i]==substr(colnames(pw_fst_f),3,3)[j]){
      intra_h<-sum(intra_h,pw_fst_f[i,j],na.rm=T)
      if(!is.na(pw_fst_f[i,j])){intra_h_c<-intra_h_c+1}
    }
  }
}

inter_loc_per<-inter_loc/inter_loc_c
intra_loc_per<-intra_loc/intra_loc_c
intra_h_per<-intra_h/intra_h_c
tot<-(inter_loc_per+intra_loc_per+intra_h_per)

inter_loc_per/tot*100
intra_loc_per/tot*100
intra_h_per/tot*100

#Migration diagrams
pdf('figs/net_all_v2_eff.pdf', width=10, height=7.5)
par(mfrow=c(3,4))
par(mar=c(0.2,0.2,0.2,0.2)+0.1)
count<-1
for(i in 1:length(files)){
  if(files[i]=="pw_fst_f_hum_pop.txt"){plot.new()}
  if(files[i]!="pw_fst_f_hum_pop.txt"){
    pw_fst_f<-read.table(files[i],sep="\t",header=TRUE)
    pw_fst_f[is.na(pw_fst_f)]<-0;pw_fst_f<-pw_fst_f+t(pw_fst_f);pw_fst_f<-as.matrix(pw_fst_f)
    ne<-(1/pw_fst_f-1)/4
    ne[which(ne<1)]<-NA
    colnames(ne)<-merge(data.frame(name_short=colnames(ne)),names[,c("name_short","name_short2")],by="name_short",all.x=T,all.y=F)[,"name_short2"]
    qgraph(ne,layout='spring',label.cex=1.3)
    legend(x="topleft",legend=LETTERS[count],bty="n",cex=1)
    count<-count+1
  }
}
dev.off()

pdf('figs/net_all_colors_spring_v3.pdf', width=10, height=7.5)
par(mfrow=c(3,4))
par(mar=c(0.2,0.2,0.2,0.2)+0.1)
count<-1
for(i in 1:length(files)){
  if(files[i]=="pw_fst_f_hum_pop.txt"){plot.new()}
  if(files[i]!="pw_fst_f_hum_pop.txt"){
    pw_fst_f<-read.table(files[i],sep="\t",header=TRUE)
    pw_fst_f[is.na(pw_fst_f)]<-0;pw_fst_f<-pw_fst_f+t(pw_fst_f);pw_fst_f<-as.matrix(pw_fst_f)
    
    node_colors<-as.factor(substr(rownames(pw_fst_f),1,2))
    node_colors_list<-as.data.frame(table(node_colors))
    node_colors_list$Freq<-rownames(node_colors_list)
    node_colors_list_big<-merge(as.data.frame(node_colors),node_colors_list,by="node_colors",all.x=T)
    node_colors_list_big$ids<-as.numeric(rownames(node_colors_list_big))
    tab<-dcast(node_colors_list_big, ids ~ node_colors)
    rownames(tab)<-tab[,"ids"]
    tab<-tab[,-c(1)]
    tab<-lapply(as.list(tab), function(x) x[!is.na(x)])
    
    color<-merge(node_colors_list,names[,c("pop","color")],by.x="node_colors",by.y="pop")
    color<-color[!duplicated(color),]
  
    ne<-(1/pw_fst_f-1)/4
    #ne[which(ne<1)]<-NA
    ne[which(ne==Inf)]<-NA
    print(max(ne,na.rm=T))
    colnames(ne)<-merge(data.frame(name_short=colnames(ne)),names[,c("name_short","name_short2")],by="name_short",all.x=T,all.y=F)[,"name_short2"]
    qgraph(ne,layout='spring',vsize=3.5,groups=tab,color=color$color,borders=F,shape="circle",node.width=2.5,node.height=1.5,label.cex=1.3,legend=F,label.color="white")
    #qgraph((1/pw_fst_f-1)/4,layout='groups',vsize=3,groups=tab,color=color$color,borders=F,shape="circle",node.width=2.5,node.height=1.5,label.cex=1.3,legend=F,label.color="white")
    legend(x="topleft",legend=LETTERS[count],bty="n",cex=1)
    #legend(x="topleft",legend=paste(LETTERS[count]," (",as.character(round(max(ne,na.rm=T),1)),")",sep=""),bty="n",cex=1)
    count<-count+1
  }
}
dev.off()

cex_va<-1.5
pdf('figs/mantels_all_v4.pdf', width=15, height=55)
par(mfrow=c(length(files)-1,3))
par(mar=c(5,5,1,1)+0.1)
count<-1
for(i in 1:length(files)){
  if(files[i]!="pw_fst_f_hum_pop.txt"){
    pw_fst_f<-read.table(files[i],sep="\t",header=TRUE)
    pw_fst_f[is.na(pw_fst_f)]<-0;pw_fst_f<-pw_fst_f+t(pw_fst_f);pw_fst_f<-as.matrix(pw_fst_f)
    
    geo<-names[,c("lon","lat")]
    rownames(geo)<-names$name_short
    #rownames(geo)<-names$pop_sp
    geo<-geo[rownames(pw_fst_f),]
    pw_geo<-as.matrix(distm(geo,fun=distHaversine))
    rownames(pw_geo)<-rownames(geo)
    colnames(pw_geo)<-rownames(geo)
    #rownames(pw_geo)<-names$pop_sp
    #colnames(pw_geo)<-names$pop_sp
    
    eco_alt<-names[,c("eco_alt")]
    names(eco_alt)<-names$name_short
    eco_alt<-eco_alt[rownames(pw_fst_f)]
    #names(eco_alt)<-names$pop_sp
    pw_eco_alt<-as.matrix(dist(eco_alt,method="euclidean",diag=T,upper=T))
    
    eco_hum<-names[,c("eco_hum")]
    names(eco_hum)<-names$name_short
    eco_hum<-eco_hum[rownames(pw_fst_f)]
    #names(eco_hum)<-names$pop_sp
    pw_eco_hum<-as.matrix(dist(eco_hum,method="euclidean",diag=T,upper=T))
    
    ma<-mantel.test(pw_fst_f/(1-pw_fst_f),pw_geo,nperm = 999)
    mb<-mantel.test(pw_fst_f/(1-pw_fst_f),pw_eco_alt,nperm = 999)
    mc<-mantel.test(pw_fst_f/(1-pw_fst_f),pw_eco_hum,nperm = 999)
    n<-dim(pw_fst_f)[1]*(dim(pw_fst_f)[1]-1)/2
    pops<-dim(pw_fst_f)[1]
    stata<-cbind(analysis=files[i],Pops=pops,N=n,geo_z=ma$z.stat,gep_p=ma$p,alt_z=mb$z.stat,alt_p=mb$p,hum_z=mc$z.stat,hum_p=mc$p)
    if(i==1){matels_stats<-stata}
    if(i!=1){matels_stats<-rbind(matels_stats,stata)}
    
    ca<-cor.test(pw_fst_f/(1-pw_fst_f),pw_geo)
    cb<-cor.test(pw_fst_f/(1-pw_fst_f),pw_eco_alt)
    cc<-cor.test(pw_fst_f/(1-pw_fst_f),pw_eco_hum)
    stata2<-cbind(analysis=files[i],Pops=pops,N=n,geo_z=ca$estimate,gep_p=ca$p.value,alt_z=cb$estimate,alt_p=cb$p.value,hum_z=cc$estimate,hum_p=cc$p.value)
    if(i==1){cor_stats<-stata2}
    if(i!=1){cor_stats<-rbind(cor_stats,stata2)}
    
    plot(pw_geo/1000,pw_fst_f/(1-pw_fst_f),pch=19,las=1,ylab=expression(F[ST]/(1-F[ST])),xlab="Geographic distance (Km)",cex=1,cex.lab=cex_va,cex.axis=cex_va)
    if(ma$p<0.05){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_geo/1000),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_geo/1000))))}
    #if(ca$p.value<0.05/n){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_geo/1000),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_geo/1000))))}
    if(ma$p<0.05){legend(x="topleft",legend=paste(LETTERS[count],"(i)    ","R = ",round(ca$estimate,2),", p < 0.001",sep=""),bty="n",cex=cex_va)}
    if(!ma$p<0.05){legend(x="topleft",legend=paste(LETTERS[count],"(i)",sep=""),bty="n",cex=cex_va)}
    abline(h=1,lty=2, col="darkgray")
    
    plot(jitter(pw_eco_alt),pw_fst_f/(1-pw_fst_f),xaxt='n',pch=19,las=1,ylab=expression(F[ST]/(1-F[ST])),xlab="Ecological distance ('Frost')",cex=1,cex.lab=cex_va,cex.axis=cex_va)
    axis(1,at=0:2,labels=c(0:2),cex.lab=cex_va,cex.axis=cex_va)
    #if(mb$p<0.05){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_eco_alt),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_eco_alt))))}
    if(cb$p.value<0.05/n){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_eco_alt),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_eco_alt))))}
    if(cb$p.value<0.05/n){legend(x="topleft",legend=paste(LETTERS[count],"(ii)    ","R = ",round(cb$estimate,2),", p < 0.001",sep=""),bty="n",cex=cex_va)}
    if(!cb$p.value<0.05/n){legend(x="topleft",legend=paste(LETTERS[count],"(ii)",sep=""),bty="n",cex=cex_va)}
    abline(h=1,lty=2, col="darkgray")
    
    plot(jitter(pw_eco_hum),pw_fst_f/(1-pw_fst_f),xaxt='n',pch=19,las=1,ylab=expression(F[ST]/(1-F[ST])),xlab="Ecological distance ('Humidity')",cex=1,cex.lab=cex_va,cex.axis=cex_va)
    axis(1,at=0:2,labels=c(0:2),cex.lab=cex_va,cex.axis=cex_va)
    #if(mc$p<0.05){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_eco_hum),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_eco_hum))))}
    if(cc$p.value<0.05/n){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_eco_hum),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_eco_hum))))}
    if(cc$p.value<0.05/n){legend(x="topleft",legend=paste(LETTERS[count],"(iii)    ","R = ",round(cc$estimate,2),", p < 0.001",sep=""),bty="n",cex=cex_va)}
    if(!cc$p.value<0.05/n){legend(x="topleft",legend=paste(LETTERS[count],"(iii)",sep=""),bty="n",cex=cex_va)}
    abline(h=1,lty=2, col="darkgray")
    count<-count+1
  }
}
dev.off()
write.table(matels_stats, file="matels_stats.txt", sep="\t", dec = ".")
write.table(cor_stats, file="matels_cor_stats.txt", sep="\t", dec = ".")

files<-c("pw_fst_f.txt","pw_fst_f_pop_pop.txt","pw_fst_f_alt_ecol.txt","pw_fst_f_hum_ecol.txt")
pdf('figs/mantels_all_v4_small.pdf', width=15, height=55*4/11)
par(mfrow=c(length(files),3))
par(mar=c(5,5,1,1)+0.1)
count<-1
for(i in 1:length(files)){
  if(files[i]!="pw_fst_f_hum_pop.txt"){
    pw_fst_f<-read.table(files[i],sep="\t",header=TRUE)
    pw_fst_f[is.na(pw_fst_f)]<-0;pw_fst_f<-pw_fst_f+t(pw_fst_f);pw_fst_f<-as.matrix(pw_fst_f)
    
    geo<-names[,c("lon","lat")]
    rownames(geo)<-names$name_short
    #rownames(geo)<-names$pop_sp
    geo<-geo[rownames(pw_fst_f),]
    pw_geo<-as.matrix(distm(geo,fun=distHaversine))
    rownames(pw_geo)<-rownames(geo)
    colnames(pw_geo)<-rownames(geo)
    #rownames(pw_geo)<-names$pop_sp
    #colnames(pw_geo)<-names$pop_sp
    
    eco_alt<-names[,c("eco_alt")]
    names(eco_alt)<-names$name_short
    eco_alt<-eco_alt[rownames(pw_fst_f)]
    #names(eco_alt)<-names$pop_sp
    pw_eco_alt<-as.matrix(dist(eco_alt,method="euclidean",diag=T,upper=T))
    
    eco_hum<-names[,c("eco_hum")]
    names(eco_hum)<-names$name_short
    eco_hum<-eco_hum[rownames(pw_fst_f)]
    #names(eco_hum)<-names$pop_sp
    pw_eco_hum<-as.matrix(dist(eco_hum,method="euclidean",diag=T,upper=T))
    
    ma<-mantel.test(pw_fst_f/(1-pw_fst_f),pw_geo,nperm = 999)
    mb<-mantel.test(pw_fst_f/(1-pw_fst_f),pw_eco_alt,nperm = 999)
    mc<-mantel.test(pw_fst_f/(1-pw_fst_f),pw_eco_hum,nperm = 999)
    n<-dim(pw_fst_f)[1]*(dim(pw_fst_f)[1]-1)/2
    stata<-cbind(analysis=files[i],N=n,geo_z=ma$z.stat,gep_p=ma$p,alt_z=mb$z.stat,alt_p=mb$p,hum_z=mc$z.stat,hum_p=mc$p)
    if(i==1){matels_stats<-stata}
    if(i!=1){matels_stats<-rbind(matels_stats,stata)}
    
    ca<-cor.test(pw_fst_f/(1-pw_fst_f),pw_geo)
    cb<-cor.test(pw_fst_f/(1-pw_fst_f),pw_eco_alt)
    cc<-cor.test(pw_fst_f/(1-pw_fst_f),pw_eco_hum)
    stata2<-cbind(analysis=files[i],N=n,geo_z=ca$estimate,gep_p=ca$p.value,alt_z=cb$estimate,alt_p=cb$p.value,hum_z=cc$estimate,hum_p=cc$p.value)
    if(i==1){cor_stats<-stata2}
    if(i!=1){cor_stats<-rbind(cor_stats,stata2)}
    
    plot(pw_geo/1000,pw_fst_f/(1-pw_fst_f),pch=19,las=1,ylab=expression(F[ST]/(1-F[ST])),xlab="Geographic distance (Km)",cex=1,cex.lab=cex_va,cex.axis=cex_va)
    if(ma$p<0.05){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_geo/1000),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_geo/1000))))}
    #if(ca$p.value<0.05/n){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_geo/1000),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_geo/1000))))}
    if(ma$p<0.05){legend(x="topleft",legend=paste(LETTERS[count],"(i)    ","R = ",round(ca$estimate,2),", p < 0.001",sep=""),bty="n",cex=cex_va)}
    if(!ma$p<0.05){legend(x="topleft",legend=paste(LETTERS[count],"(i)",sep=""),bty="n",cex=cex_va)}
    abline(h=1,lty=2, col="darkgray")
    count<-count+1
    
    plot(jitter(pw_eco_alt),pw_fst_f/(1-pw_fst_f),xaxt='n',pch=19,las=1,ylab=expression(F[ST]/(1-F[ST])),xlab="Ecological distance ('Frost')",cex=1,cex.lab=cex_va,cex.axis=cex_va)
    axis(1,at=0:2,labels=c(0:2),cex.lab=cex_va,cex.axis=cex_va)
    #if(mb$p<0.05){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_eco_alt),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_eco_alt))))}
    if(cb$p.value<0.05/n){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_eco_alt),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_eco_alt))))}
    if(cb$p.value<0.05/n){legend(x="topleft",legend=paste(LETTERS[count],"(ii)    ","R = ",round(cb$estimate,2),", p < 0.001",sep=""),bty="n",cex=cex_va)}
    if(!cb$p.value<0.05/n){legend(x="topleft",legend=paste(LETTERS[count],"(ii)",sep=""),bty="n",cex=cex_va)}
    abline(h=1,lty=2, col="darkgray")
    count<-count+1
    
    plot(jitter(pw_eco_hum),pw_fst_f/(1-pw_fst_f),xaxt='n',pch=19,las=1,ylab=expression(F[ST]/(1-F[ST])),xlab="Ecological distance ('Humidity')",cex=1,cex.lab=cex_va,cex.axis=cex_va)
    axis(1,at=0:2,labels=c(0:2),cex.lab=cex_va,cex.axis=cex_va)
    #if(mc$p<0.05){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_eco_hum),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_eco_hum))))}
    if(cc$p.value<0.05/n){lines(col="darkgray",lty=1,lwd=0.5,as.vector(pw_eco_hum),fitted(lm(as.vector(pw_fst_f/(1-pw_fst_f))~as.vector(pw_eco_hum))))}
    if(cc$p.value<0.05/n){legend(x="topleft",legend=paste(LETTERS[count],"(iii)    ","R = ",round(cc$estimate,2),", p < 0.001",sep=""),bty="n",cex=cex_va)}
    if(!cc$p.value<0.05/n){legend(x="topleft",legend=paste(LETTERS[count],"(iii)",sep=""),bty="n",cex=cex_va)}
    abline(h=1,lty=2, col="darkgray")
    count<-count+1
  }
}
dev.off()

#Outliers model
mlm<-read.table("mlm.txt",sep="\t",header=TRUE)
glm<-read.table("glm.txt",sep="\t",header=TRUE)

mlm<-read.table("mlm_ecol.txt",sep="\t",header=TRUE)
glm<-read.table("glm_ecol.txt",sep="\t",header=TRUE)

mlm<-read.table("mlm_pop.txt",sep="\t",header=TRUE)
glm<-read.table("glm_pop.txt",sep="\t",header=TRUE)

snp_n<-dim(glm)[1]/3
mlm$p_log<--log10(mlm$p)
glm$p_log<--log10(glm$p)
bf<--log10(0.05/snp_n)

mlm_sig<-mlm[!is.na(mlm$p_log)&mlm$p_log>bf,]
glm_sig<-glm[!is.na(glm$p_log)&glm$p_log>bf,]
table(glm_sig$Trait)
table(mlm_sig$Trait)

snps_alt<-snps[,c(1,glm_sig[glm_sig$Trait=="Alt","Marker"],snp_n+2)]
snps_hum<-snps[,c(1,glm_sig[glm_sig$Trait=="Hum","Marker"],snp_n+2)]
snps_pop<-snps[,c(1,glm_sig[glm_sig$Trait=="Pop","Marker"],snp_n+2)]

#QQ Plots
pdf('figs/QQ.pdf', width=10, height=20)
files_qq<-c("glm.txt","mlm.txt","glm_ecol.txt","mlm_ecol.txt","glm_pop.txt","mlm_pop.txt")
trait<-c("Pop","Alt","Hum")
par(mfrow=c(6,3))
par(mar=c(4.5,4.5,1,1)+0.1)
cex_p<-1 
counted<-1
for(i in files_qq){
  for(j in trait){
    m<-read.table(i,sep="\t",header=TRUE)
    m<-m[m$Trait==j,]
    observed<-sort(m$p)
    lobs<-(-(log10(observed)))
    expected<-c(1:length(observed)) 
    lexp<-(-(log10(expected/(length(expected)+1))))
    m$sex_chi_log<-(-log10(m$p))
    max_sex_chi_log<-max(m$sex_chi_log,na.rm=T)+1
    plot(lexp,lobs,pch=20,ylab=expression(-log[10]~~(p-value)),xlab=expression(Exp.-log[10]~~(p-value)),main="",ylim=c(0,max_sex_chi_log),las=1,cex=cex_p)
    #lines(c(0,max_sex_chi_log),c(0,max_sex_chi_log))
    n_mar<-dim(m)[1]/3
    if(max_sex_chi_log>=-log10(0.05/n_mar)){abline(h=-log10(0.05/n_mar),lty=2,col="darkgray")}
    legend("topleft",toupper(letters[counted]),bty="n",cex=1);counted<-counted+1
    #legend(0,max_sex_chi_log+0,toupper(letters[counted]),bty="n",cex=1);counted<-counted+1
  }
}
dev.off()

#Evanno
ev<-data.frame(K=c(3:19),D=c(0.368,12.444,0.437,1449.877,1.156,1.932,1752.974,.957,1.068,2.222,2.029,3.776,3.026,0.038,0.377,39.084,6.145))
pdf('figs/Evanno.pdf', width=7, height=7)
par(mfrow=c(1,1))
par(mar=c(4,4,1,1)+0.1)
cex_p<-1
plot(D~K,ev,pch=19,las=1,xlab="K",ylab=expression(Delta~~K),axes=FALSE)
axis(side=1,at=seq(3,19,by=1),las=1,labels=c(3:19))
axis(side=2,at=seq(0,2100,by=500),las=1,labels=seq(0,2100,by=500))
lines(D~K,ev)
dev.off()

#Getting per-marker statistics
load("pw_fst.RData")
load("pw_fis.RData")
load("pw_he.RData")

load("pw_fst_hum_ecol.RData")
load("pw_fis_hum_ecol.RData")
load("pw_he_hum_ecol.RData")

mk<-mk_saved
mki<-mki_saved
mkhe<-mkhe_saved
library(reshape2)
mk_df<-as.data.frame(melt(mk))
mki_df<-as.data.frame(melt(mki))
mkhe_df<-as.data.frame(melt(mkhe))
mk_all_df<-cbind(mk_df,mki_df[,"value"],mkhe_df[,"value"])
colnames(mk_all_df)<-c("pop1","pop2","fst","marker","fis","he")
mk_all_df<-merge(mk_all_df,names[,c("pop_sp","eco_alt")],by.x="pop1",by.y="pop_sp")
mk_all_df<-merge(mk_all_df,names[,c("pop_sp","eco_alt")],by.x="pop2",by.y="pop_sp")
mk_all_df$within<-FALSE
mk_all_df[which(mk_all_df$eco_alt.x==mk_all_df$eco_alt.y),"within"]<-TRUE
write.table(mk_all_df, file="pw_all_df.txt", sep="\t", dec = ".")

#Per-marker properties

mk_all_df<-read.table("pw_all_df.txt",sep="\t",header=TRUE)

par(mfrow=c(1,1))
par(mar=c(5,5,1,1)+0.1)
hist(mk_all_df$fst,xlab=expression(F[ST]),main="",las=0)
hist(mk_all_df[mk_all_df$within==FALSE,]$fst,add=T,col="lightgray")
hist(mk_all_df[mk_all_df$within==TRUE,]$fst,add=T,col="darkgray")
abline(v=0.95,lyt=5,col="lightgray")

par(mfrow=c(1,2))
par(mar=c(5,5,1,1)+0.1)
plot(fst~he,mk_all_df[mk_all_df$within==FALSE,],pch=19,las=1,ylab=expression(F[ST]),xlab=expression(H[e]),cex=0.8)
abline(h=0.95,lyt=5,col="lightgray")
legend(x="topleft",legend="A",bty="n",cex=1)
plot(fst~he,mk_all_df[mk_all_df$within==TRUE,],pch=19,las=1,ylab=expression(F[ST]),xlab=expression(H[e]),cex=0.8)
abline(h=0.95,lyt=5,col="lightgray")
legend(x="topleft",legend="B",bty="n",cex=1)

par(mfrow=c(1,2))
par(mar=c(5,5,1,1)+0.1)
plot(fst~fis,mk_all_df[mk_all_df$within==FALSE,],pch=19,las=1,ylab=expression(F[ST]),xlab=expression(F[IS]),cex=0.8)
abline(h=0.95,lyt=5,col="lightgray")
legend(x="topleft",legend="A",bty="n",cex=1)
plot(fst~fis,mk_all_df[mk_all_df$within==TRUE,],pch=19,las=1,ylab=expression(F[ST]),xlab=expression(F[IS]),cex=0.8)
abline(h=0.95,lyt=5,col="lightgray")
legend(x="topleft",legend="B",bty="n",cex=1)

#Make dendograms per pop
par(mfrow=c(1,1))
pw_fst_f<-read.table("pw_fst_f.txt",sep="\t",header=TRUE)
pw_fst_f[is.na(pw_fst_f)]<-0;pw_fst_f<-pw_fst_f+t(pw_fst_f);pw_fst_f<-as.matrix(pw_fst_f)
hc<-hclust(dist(pw_fst_f),method="average")
hcd=as.dendrogram(hc)
par(mar=c(6,4,2,2)+0.1)
plot(hc,cex=1,hang=-1)
library("ape")
plot(as.phylo(hc),cex=0.8,type="unrooted",tip.color="black")
plot(as.phylo(hc),cex=0.8,type="fan")
names2<-names
row.names(names2)<-names2$name_short
tree<-as.phylo(hc)
plot(tree,type="fan",cex=0.8,tip.color=as.character(names2[tree$tip.label,"color"]),
     edge.color="gray", 
     edge.width=1,use.edge.length=TRUE)
plot(tree,type="unrooted",cex=0.7,align.tip.label=T,
     tip.color=as.character(names2[tree$tip.label,"color"]),
     edge.color="darkgray",
     edge.width=1,use.edge.length=TRUE,col="gray80")

library(pvclust)
result<-pvclust(pw_fst_f, method.dist="cor", method.hclust="average", nboot=1000)
plot(result)
pvrect(result,alpha=0.95) 

#Dendogram per individuals

par(mfrow=c(1,2))
par(mar=c(1,1,1,1)+0.1)
pw_fst_f<-read.table("pw_fst_f.txt",sep="\t",header=TRUE)
pw_fst_f[is.na(pw_fst_f)]<-0;pw_fst_f<-pw_fst_f+t(pw_fst_f);pw_fst_f<-as.matrix(pw_fst_f)
hc<-hclust(dist(pw_fst_f),method="average")
names2<-names
row.names(names2)<-names2$name_short
tree<-as.phylo(hc)
plot(tree,type="unrooted",cex=0.7,align.tip.label=T,
     tip.color=as.character(names2[tree$tip.label,"color"]),
     edge.color="darkgray",
     edge.width=1,use.edge.length=TRUE,col="gray80")

dist<-read.table("dist.txt",sep="\t",row.names=1)
colnames(dist)<-rownames(dist)
hc<-hclust(dist(dist),method="average")
names2<-names
row.names(names2)<-names2$name_short
tree<-as.phylo(hc) 
plot(tree,type="unrooted",cex=0.3,align.tip.label=T,show.tip.label=F,
     tip.color=as.character(names2[as.factor(substr(tree$tip.label,1,4)),"color"]),
     edge.color="darkgray",
     edge.width=1,use.edge.length=TRUE,col="gray80")
